// +build go1.9

// Copyright 2020 Microsoft Corporation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// This code was auto-generated by:
// github.com/Azure/azure-sdk-for-go/tools/profileBuilder

package cdn

import (
	"context"

	original "github.com/Azure/azure-sdk-for-go/services/preview/cdn/mgmt/2020-04-15/cdn"
)

const (
	DefaultBaseURI = original.DefaultBaseURI
)

type ActionType = original.ActionType

const (
	Allow    ActionType = original.Allow
	Block    ActionType = original.Block
	Log      ActionType = original.Log
	Redirect ActionType = original.Redirect
)

type Algorithm = original.Algorithm

const (
	SHA256 Algorithm = original.SHA256
)

type CacheBehavior = original.CacheBehavior

const (
	BypassCache  CacheBehavior = original.BypassCache
	Override     CacheBehavior = original.Override
	SetIfMissing CacheBehavior = original.SetIfMissing
)

type CertificateSource = original.CertificateSource

const (
	CertificateSourceAzureKeyVault               CertificateSource = original.CertificateSourceAzureKeyVault
	CertificateSourceCdn                         CertificateSource = original.CertificateSourceCdn
	CertificateSourceCustomDomainHTTPSParameters CertificateSource = original.CertificateSourceCustomDomainHTTPSParameters
)

type CertificateType = original.CertificateType

const (
	Dedicated CertificateType = original.Dedicated
	Shared    CertificateType = original.Shared
)

type CookiesOperator = original.CookiesOperator

const (
	Any                CookiesOperator = original.Any
	BeginsWith         CookiesOperator = original.BeginsWith
	Contains           CookiesOperator = original.Contains
	EndsWith           CookiesOperator = original.EndsWith
	Equal              CookiesOperator = original.Equal
	GreaterThan        CookiesOperator = original.GreaterThan
	GreaterThanOrEqual CookiesOperator = original.GreaterThanOrEqual
	LessThan           CookiesOperator = original.LessThan
	LessThanOrEqual    CookiesOperator = original.LessThanOrEqual
)

type CustomDomainResourceState = original.CustomDomainResourceState

const (
	Active   CustomDomainResourceState = original.Active
	Creating CustomDomainResourceState = original.Creating
	Deleting CustomDomainResourceState = original.Deleting
)

type CustomHTTPSProvisioningState = original.CustomHTTPSProvisioningState

const (
	Disabled  CustomHTTPSProvisioningState = original.Disabled
	Disabling CustomHTTPSProvisioningState = original.Disabling
	Enabled   CustomHTTPSProvisioningState = original.Enabled
	Enabling  CustomHTTPSProvisioningState = original.Enabling
	Failed    CustomHTTPSProvisioningState = original.Failed
)

type CustomHTTPSProvisioningSubstate = original.CustomHTTPSProvisioningSubstate

const (
	CertificateDeleted                            CustomHTTPSProvisioningSubstate = original.CertificateDeleted
	CertificateDeployed                           CustomHTTPSProvisioningSubstate = original.CertificateDeployed
	DeletingCertificate                           CustomHTTPSProvisioningSubstate = original.DeletingCertificate
	DeployingCertificate                          CustomHTTPSProvisioningSubstate = original.DeployingCertificate
	DomainControlValidationRequestApproved        CustomHTTPSProvisioningSubstate = original.DomainControlValidationRequestApproved
	DomainControlValidationRequestRejected        CustomHTTPSProvisioningSubstate = original.DomainControlValidationRequestRejected
	DomainControlValidationRequestTimedOut        CustomHTTPSProvisioningSubstate = original.DomainControlValidationRequestTimedOut
	IssuingCertificate                            CustomHTTPSProvisioningSubstate = original.IssuingCertificate
	PendingDomainControlValidationREquestApproval CustomHTTPSProvisioningSubstate = original.PendingDomainControlValidationREquestApproval
	SubmittingDomainControlValidationRequest      CustomHTTPSProvisioningSubstate = original.SubmittingDomainControlValidationRequest
)

type CustomRuleEnabledState = original.CustomRuleEnabledState

const (
	CustomRuleEnabledStateDisabled CustomRuleEnabledState = original.CustomRuleEnabledStateDisabled
	CustomRuleEnabledStateEnabled  CustomRuleEnabledState = original.CustomRuleEnabledStateEnabled
)

type DestinationProtocol = original.DestinationProtocol

const (
	HTTP         DestinationProtocol = original.HTTP
	HTTPS        DestinationProtocol = original.HTTPS
	MatchRequest DestinationProtocol = original.MatchRequest
)

type EndpointResourceState = original.EndpointResourceState

const (
	EndpointResourceStateCreating EndpointResourceState = original.EndpointResourceStateCreating
	EndpointResourceStateDeleting EndpointResourceState = original.EndpointResourceStateDeleting
	EndpointResourceStateRunning  EndpointResourceState = original.EndpointResourceStateRunning
	EndpointResourceStateStarting EndpointResourceState = original.EndpointResourceStateStarting
	EndpointResourceStateStopped  EndpointResourceState = original.EndpointResourceStateStopped
	EndpointResourceStateStopping EndpointResourceState = original.EndpointResourceStateStopping
)

type GeoFilterActions = original.GeoFilterActions

const (
	GeoFilterActionsAllow GeoFilterActions = original.GeoFilterActionsAllow
	GeoFilterActionsBlock GeoFilterActions = original.GeoFilterActionsBlock
)

type HeaderAction = original.HeaderAction

const (
	Append    HeaderAction = original.Append
	Delete    HeaderAction = original.Delete
	Overwrite HeaderAction = original.Overwrite
)

type HealthProbeRequestType = original.HealthProbeRequestType

const (
	GET    HealthProbeRequestType = original.GET
	HEAD   HealthProbeRequestType = original.HEAD
	NotSet HealthProbeRequestType = original.NotSet
)

type ManagedRuleEnabledState = original.ManagedRuleEnabledState

const (
	ManagedRuleEnabledStateDisabled ManagedRuleEnabledState = original.ManagedRuleEnabledStateDisabled
	ManagedRuleEnabledStateEnabled  ManagedRuleEnabledState = original.ManagedRuleEnabledStateEnabled
)

type MatchVariable = original.MatchVariable

const (
	Cookies       MatchVariable = original.Cookies
	PostArgs      MatchVariable = original.PostArgs
	QueryString   MatchVariable = original.QueryString
	RemoteAddr    MatchVariable = original.RemoteAddr
	RequestBody   MatchVariable = original.RequestBody
	RequestHeader MatchVariable = original.RequestHeader
	RequestMethod MatchVariable = original.RequestMethod
	RequestURI    MatchVariable = original.RequestURI
	SocketAddr    MatchVariable = original.SocketAddr
)

type MinimumTLSVersion = original.MinimumTLSVersion

const (
	None  MinimumTLSVersion = original.None
	TLS10 MinimumTLSVersion = original.TLS10
	TLS12 MinimumTLSVersion = original.TLS12
)

type Name = original.Name

const (
	NameCookies               Name = original.NameCookies
	NameDeliveryRuleCondition Name = original.NameDeliveryRuleCondition
	NameHTTPVersion           Name = original.NameHTTPVersion
	NameIsDevice              Name = original.NameIsDevice
	NamePostArgs              Name = original.NamePostArgs
	NameQueryString           Name = original.NameQueryString
	NameRemoteAddress         Name = original.NameRemoteAddress
	NameRequestBody           Name = original.NameRequestBody
	NameRequestHeader         Name = original.NameRequestHeader
	NameRequestMethod         Name = original.NameRequestMethod
	NameRequestScheme         Name = original.NameRequestScheme
	NameRequestURI            Name = original.NameRequestURI
	NameURLFileExtension      Name = original.NameURLFileExtension
	NameURLFileName           Name = original.NameURLFileName
	NameURLPath               Name = original.NameURLPath
)

type NameBasicDeliveryRuleAction = original.NameBasicDeliveryRuleAction

const (
	NameCacheExpiration      NameBasicDeliveryRuleAction = original.NameCacheExpiration
	NameCacheKeyQueryString  NameBasicDeliveryRuleAction = original.NameCacheKeyQueryString
	NameDeliveryRuleAction   NameBasicDeliveryRuleAction = original.NameDeliveryRuleAction
	NameModifyRequestHeader  NameBasicDeliveryRuleAction = original.NameModifyRequestHeader
	NameModifyResponseHeader NameBasicDeliveryRuleAction = original.NameModifyResponseHeader
	NameURLRedirect          NameBasicDeliveryRuleAction = original.NameURLRedirect
	NameURLRewrite           NameBasicDeliveryRuleAction = original.NameURLRewrite
)

type Operator = original.Operator

const (
	OperatorAny                Operator = original.OperatorAny
	OperatorBeginsWith         Operator = original.OperatorBeginsWith
	OperatorContains           Operator = original.OperatorContains
	OperatorEndsWith           Operator = original.OperatorEndsWith
	OperatorEqual              Operator = original.OperatorEqual
	OperatorGeoMatch           Operator = original.OperatorGeoMatch
	OperatorGreaterThan        Operator = original.OperatorGreaterThan
	OperatorGreaterThanOrEqual Operator = original.OperatorGreaterThanOrEqual
	OperatorIPMatch            Operator = original.OperatorIPMatch
	OperatorLessThan           Operator = original.OperatorLessThan
	OperatorLessThanOrEqual    Operator = original.OperatorLessThanOrEqual
	OperatorRegEx              Operator = original.OperatorRegEx
)

type OptimizationType = original.OptimizationType

const (
	DynamicSiteAcceleration     OptimizationType = original.DynamicSiteAcceleration
	GeneralMediaStreaming       OptimizationType = original.GeneralMediaStreaming
	GeneralWebDelivery          OptimizationType = original.GeneralWebDelivery
	LargeFileDownload           OptimizationType = original.LargeFileDownload
	VideoOnDemandMediaStreaming OptimizationType = original.VideoOnDemandMediaStreaming
)

type OriginGroupResourceState = original.OriginGroupResourceState

const (
	OriginGroupResourceStateActive   OriginGroupResourceState = original.OriginGroupResourceStateActive
	OriginGroupResourceStateCreating OriginGroupResourceState = original.OriginGroupResourceStateCreating
	OriginGroupResourceStateDeleting OriginGroupResourceState = original.OriginGroupResourceStateDeleting
)

type OriginResourceState = original.OriginResourceState

const (
	OriginResourceStateActive   OriginResourceState = original.OriginResourceStateActive
	OriginResourceStateCreating OriginResourceState = original.OriginResourceStateCreating
	OriginResourceStateDeleting OriginResourceState = original.OriginResourceStateDeleting
)

type ParamIndicator = original.ParamIndicator

const (
	Expires   ParamIndicator = original.Expires
	KeyID     ParamIndicator = original.KeyID
	Signature ParamIndicator = original.Signature
)

type PolicyEnabledState = original.PolicyEnabledState

const (
	PolicyEnabledStateDisabled PolicyEnabledState = original.PolicyEnabledStateDisabled
	PolicyEnabledStateEnabled  PolicyEnabledState = original.PolicyEnabledStateEnabled
)

type PolicyMode = original.PolicyMode

const (
	Detection  PolicyMode = original.Detection
	Prevention PolicyMode = original.Prevention
)

type PolicyResourceState = original.PolicyResourceState

const (
	PolicyResourceStateCreating  PolicyResourceState = original.PolicyResourceStateCreating
	PolicyResourceStateDeleting  PolicyResourceState = original.PolicyResourceStateDeleting
	PolicyResourceStateDisabled  PolicyResourceState = original.PolicyResourceStateDisabled
	PolicyResourceStateDisabling PolicyResourceState = original.PolicyResourceStateDisabling
	PolicyResourceStateEnabled   PolicyResourceState = original.PolicyResourceStateEnabled
	PolicyResourceStateEnabling  PolicyResourceState = original.PolicyResourceStateEnabling
)

type PostArgsOperator = original.PostArgsOperator

const (
	PostArgsOperatorAny                PostArgsOperator = original.PostArgsOperatorAny
	PostArgsOperatorBeginsWith         PostArgsOperator = original.PostArgsOperatorBeginsWith
	PostArgsOperatorContains           PostArgsOperator = original.PostArgsOperatorContains
	PostArgsOperatorEndsWith           PostArgsOperator = original.PostArgsOperatorEndsWith
	PostArgsOperatorEqual              PostArgsOperator = original.PostArgsOperatorEqual
	PostArgsOperatorGreaterThan        PostArgsOperator = original.PostArgsOperatorGreaterThan
	PostArgsOperatorGreaterThanOrEqual PostArgsOperator = original.PostArgsOperatorGreaterThanOrEqual
	PostArgsOperatorLessThan           PostArgsOperator = original.PostArgsOperatorLessThan
	PostArgsOperatorLessThanOrEqual    PostArgsOperator = original.PostArgsOperatorLessThanOrEqual
)

type PrivateEndpointStatus = original.PrivateEndpointStatus

const (
	Approved     PrivateEndpointStatus = original.Approved
	Disconnected PrivateEndpointStatus = original.Disconnected
	Pending      PrivateEndpointStatus = original.Pending
	Rejected     PrivateEndpointStatus = original.Rejected
	Timeout      PrivateEndpointStatus = original.Timeout
)

type ProbeProtocol = original.ProbeProtocol

const (
	ProbeProtocolHTTP   ProbeProtocol = original.ProbeProtocolHTTP
	ProbeProtocolHTTPS  ProbeProtocol = original.ProbeProtocolHTTPS
	ProbeProtocolNotSet ProbeProtocol = original.ProbeProtocolNotSet
)

type ProfileResourceState = original.ProfileResourceState

const (
	ProfileResourceStateActive   ProfileResourceState = original.ProfileResourceStateActive
	ProfileResourceStateCreating ProfileResourceState = original.ProfileResourceStateCreating
	ProfileResourceStateDeleting ProfileResourceState = original.ProfileResourceStateDeleting
	ProfileResourceStateDisabled ProfileResourceState = original.ProfileResourceStateDisabled
)

type ProtocolType = original.ProtocolType

const (
	IPBased              ProtocolType = original.IPBased
	ServerNameIndication ProtocolType = original.ServerNameIndication
)

type ProvisioningState = original.ProvisioningState

const (
	ProvisioningStateCreating  ProvisioningState = original.ProvisioningStateCreating
	ProvisioningStateFailed    ProvisioningState = original.ProvisioningStateFailed
	ProvisioningStateSucceeded ProvisioningState = original.ProvisioningStateSucceeded
)

type QueryStringBehavior = original.QueryStringBehavior

const (
	Exclude    QueryStringBehavior = original.Exclude
	ExcludeAll QueryStringBehavior = original.ExcludeAll
	Include    QueryStringBehavior = original.Include
	IncludeAll QueryStringBehavior = original.IncludeAll
)

type QueryStringCachingBehavior = original.QueryStringCachingBehavior

const (
	QueryStringCachingBehaviorBypassCaching     QueryStringCachingBehavior = original.QueryStringCachingBehaviorBypassCaching
	QueryStringCachingBehaviorIgnoreQueryString QueryStringCachingBehavior = original.QueryStringCachingBehaviorIgnoreQueryString
	QueryStringCachingBehaviorNotSet            QueryStringCachingBehavior = original.QueryStringCachingBehaviorNotSet
	QueryStringCachingBehaviorUseQueryString    QueryStringCachingBehavior = original.QueryStringCachingBehaviorUseQueryString
)

type QueryStringOperator = original.QueryStringOperator

const (
	QueryStringOperatorAny                QueryStringOperator = original.QueryStringOperatorAny
	QueryStringOperatorBeginsWith         QueryStringOperator = original.QueryStringOperatorBeginsWith
	QueryStringOperatorContains           QueryStringOperator = original.QueryStringOperatorContains
	QueryStringOperatorEndsWith           QueryStringOperator = original.QueryStringOperatorEndsWith
	QueryStringOperatorEqual              QueryStringOperator = original.QueryStringOperatorEqual
	QueryStringOperatorGreaterThan        QueryStringOperator = original.QueryStringOperatorGreaterThan
	QueryStringOperatorGreaterThanOrEqual QueryStringOperator = original.QueryStringOperatorGreaterThanOrEqual
	QueryStringOperatorLessThan           QueryStringOperator = original.QueryStringOperatorLessThan
	QueryStringOperatorLessThanOrEqual    QueryStringOperator = original.QueryStringOperatorLessThanOrEqual
)

type RedirectType = original.RedirectType

const (
	Found             RedirectType = original.Found
	Moved             RedirectType = original.Moved
	PermanentRedirect RedirectType = original.PermanentRedirect
	TemporaryRedirect RedirectType = original.TemporaryRedirect
)

type RemoteAddressOperator = original.RemoteAddressOperator

const (
	RemoteAddressOperatorAny      RemoteAddressOperator = original.RemoteAddressOperatorAny
	RemoteAddressOperatorGeoMatch RemoteAddressOperator = original.RemoteAddressOperatorGeoMatch
	RemoteAddressOperatorIPMatch  RemoteAddressOperator = original.RemoteAddressOperatorIPMatch
)

type RequestBodyOperator = original.RequestBodyOperator

const (
	RequestBodyOperatorAny                RequestBodyOperator = original.RequestBodyOperatorAny
	RequestBodyOperatorBeginsWith         RequestBodyOperator = original.RequestBodyOperatorBeginsWith
	RequestBodyOperatorContains           RequestBodyOperator = original.RequestBodyOperatorContains
	RequestBodyOperatorEndsWith           RequestBodyOperator = original.RequestBodyOperatorEndsWith
	RequestBodyOperatorEqual              RequestBodyOperator = original.RequestBodyOperatorEqual
	RequestBodyOperatorGreaterThan        RequestBodyOperator = original.RequestBodyOperatorGreaterThan
	RequestBodyOperatorGreaterThanOrEqual RequestBodyOperator = original.RequestBodyOperatorGreaterThanOrEqual
	RequestBodyOperatorLessThan           RequestBodyOperator = original.RequestBodyOperatorLessThan
	RequestBodyOperatorLessThanOrEqual    RequestBodyOperator = original.RequestBodyOperatorLessThanOrEqual
)

type RequestHeaderOperator = original.RequestHeaderOperator

const (
	RequestHeaderOperatorAny                RequestHeaderOperator = original.RequestHeaderOperatorAny
	RequestHeaderOperatorBeginsWith         RequestHeaderOperator = original.RequestHeaderOperatorBeginsWith
	RequestHeaderOperatorContains           RequestHeaderOperator = original.RequestHeaderOperatorContains
	RequestHeaderOperatorEndsWith           RequestHeaderOperator = original.RequestHeaderOperatorEndsWith
	RequestHeaderOperatorEqual              RequestHeaderOperator = original.RequestHeaderOperatorEqual
	RequestHeaderOperatorGreaterThan        RequestHeaderOperator = original.RequestHeaderOperatorGreaterThan
	RequestHeaderOperatorGreaterThanOrEqual RequestHeaderOperator = original.RequestHeaderOperatorGreaterThanOrEqual
	RequestHeaderOperatorLessThan           RequestHeaderOperator = original.RequestHeaderOperatorLessThan
	RequestHeaderOperatorLessThanOrEqual    RequestHeaderOperator = original.RequestHeaderOperatorLessThanOrEqual
)

type RequestURIOperator = original.RequestURIOperator

const (
	RequestURIOperatorAny                RequestURIOperator = original.RequestURIOperatorAny
	RequestURIOperatorBeginsWith         RequestURIOperator = original.RequestURIOperatorBeginsWith
	RequestURIOperatorContains           RequestURIOperator = original.RequestURIOperatorContains
	RequestURIOperatorEndsWith           RequestURIOperator = original.RequestURIOperatorEndsWith
	RequestURIOperatorEqual              RequestURIOperator = original.RequestURIOperatorEqual
	RequestURIOperatorGreaterThan        RequestURIOperator = original.RequestURIOperatorGreaterThan
	RequestURIOperatorGreaterThanOrEqual RequestURIOperator = original.RequestURIOperatorGreaterThanOrEqual
	RequestURIOperatorLessThan           RequestURIOperator = original.RequestURIOperatorLessThan
	RequestURIOperatorLessThanOrEqual    RequestURIOperator = original.RequestURIOperatorLessThanOrEqual
)

type ResourceType = original.ResourceType

const (
	MicrosoftCdnProfilesEndpoints ResourceType = original.MicrosoftCdnProfilesEndpoints
)

type ResponseBasedDetectedErrorTypes = original.ResponseBasedDetectedErrorTypes

const (
	ResponseBasedDetectedErrorTypesNone             ResponseBasedDetectedErrorTypes = original.ResponseBasedDetectedErrorTypesNone
	ResponseBasedDetectedErrorTypesTCPAndHTTPErrors ResponseBasedDetectedErrorTypes = original.ResponseBasedDetectedErrorTypesTCPAndHTTPErrors
	ResponseBasedDetectedErrorTypesTCPErrorsOnly    ResponseBasedDetectedErrorTypes = original.ResponseBasedDetectedErrorTypesTCPErrorsOnly
)

type SkuName = original.SkuName

const (
	CustomVerizon     SkuName = original.CustomVerizon
	PremiumChinaCdn   SkuName = original.PremiumChinaCdn
	PremiumVerizon    SkuName = original.PremiumVerizon
	StandardAkamai    SkuName = original.StandardAkamai
	StandardChinaCdn  SkuName = original.StandardChinaCdn
	StandardMicrosoft SkuName = original.StandardMicrosoft
	StandardVerizon   SkuName = original.StandardVerizon
)

type Transform = original.Transform

const (
	Lowercase Transform = original.Lowercase
	Uppercase Transform = original.Uppercase
)

type TransformType = original.TransformType

const (
	TransformTypeLowercase   TransformType = original.TransformTypeLowercase
	TransformTypeRemoveNulls TransformType = original.TransformTypeRemoveNulls
	TransformTypeTrim        TransformType = original.TransformTypeTrim
	TransformTypeUppercase   TransformType = original.TransformTypeUppercase
	TransformTypeURLDecode   TransformType = original.TransformTypeURLDecode
	TransformTypeURLEncode   TransformType = original.TransformTypeURLEncode
)

type URLFileExtensionOperator = original.URLFileExtensionOperator

const (
	URLFileExtensionOperatorAny                URLFileExtensionOperator = original.URLFileExtensionOperatorAny
	URLFileExtensionOperatorBeginsWith         URLFileExtensionOperator = original.URLFileExtensionOperatorBeginsWith
	URLFileExtensionOperatorContains           URLFileExtensionOperator = original.URLFileExtensionOperatorContains
	URLFileExtensionOperatorEndsWith           URLFileExtensionOperator = original.URLFileExtensionOperatorEndsWith
	URLFileExtensionOperatorEqual              URLFileExtensionOperator = original.URLFileExtensionOperatorEqual
	URLFileExtensionOperatorGreaterThan        URLFileExtensionOperator = original.URLFileExtensionOperatorGreaterThan
	URLFileExtensionOperatorGreaterThanOrEqual URLFileExtensionOperator = original.URLFileExtensionOperatorGreaterThanOrEqual
	URLFileExtensionOperatorLessThan           URLFileExtensionOperator = original.URLFileExtensionOperatorLessThan
	URLFileExtensionOperatorLessThanOrEqual    URLFileExtensionOperator = original.URLFileExtensionOperatorLessThanOrEqual
)

type URLFileNameOperator = original.URLFileNameOperator

const (
	URLFileNameOperatorAny                URLFileNameOperator = original.URLFileNameOperatorAny
	URLFileNameOperatorBeginsWith         URLFileNameOperator = original.URLFileNameOperatorBeginsWith
	URLFileNameOperatorContains           URLFileNameOperator = original.URLFileNameOperatorContains
	URLFileNameOperatorEndsWith           URLFileNameOperator = original.URLFileNameOperatorEndsWith
	URLFileNameOperatorEqual              URLFileNameOperator = original.URLFileNameOperatorEqual
	URLFileNameOperatorGreaterThan        URLFileNameOperator = original.URLFileNameOperatorGreaterThan
	URLFileNameOperatorGreaterThanOrEqual URLFileNameOperator = original.URLFileNameOperatorGreaterThanOrEqual
	URLFileNameOperatorLessThan           URLFileNameOperator = original.URLFileNameOperatorLessThan
	URLFileNameOperatorLessThanOrEqual    URLFileNameOperator = original.URLFileNameOperatorLessThanOrEqual
)

type URLPathOperator = original.URLPathOperator

const (
	URLPathOperatorAny                URLPathOperator = original.URLPathOperatorAny
	URLPathOperatorBeginsWith         URLPathOperator = original.URLPathOperatorBeginsWith
	URLPathOperatorContains           URLPathOperator = original.URLPathOperatorContains
	URLPathOperatorEndsWith           URLPathOperator = original.URLPathOperatorEndsWith
	URLPathOperatorEqual              URLPathOperator = original.URLPathOperatorEqual
	URLPathOperatorGreaterThan        URLPathOperator = original.URLPathOperatorGreaterThan
	URLPathOperatorGreaterThanOrEqual URLPathOperator = original.URLPathOperatorGreaterThanOrEqual
	URLPathOperatorLessThan           URLPathOperator = original.URLPathOperatorLessThan
	URLPathOperatorLessThanOrEqual    URLPathOperator = original.URLPathOperatorLessThanOrEqual
	URLPathOperatorWildcard           URLPathOperator = original.URLPathOperatorWildcard
)

type BaseClient = original.BaseClient
type BasicCustomDomainHTTPSParameters = original.BasicCustomDomainHTTPSParameters
type BasicDeliveryRuleAction = original.BasicDeliveryRuleAction
type BasicDeliveryRuleCondition = original.BasicDeliveryRuleCondition
type CacheExpirationActionParameters = original.CacheExpirationActionParameters
type CacheKeyQueryStringActionParameters = original.CacheKeyQueryStringActionParameters
type CertificateSourceParameters = original.CertificateSourceParameters
type CheckNameAvailabilityInput = original.CheckNameAvailabilityInput
type CheckNameAvailabilityOutput = original.CheckNameAvailabilityOutput
type CidrIPAddress = original.CidrIPAddress
type CookiesMatchConditionParameters = original.CookiesMatchConditionParameters
type CustomDomain = original.CustomDomain
type CustomDomainHTTPSParameters = original.CustomDomainHTTPSParameters
type CustomDomainListResult = original.CustomDomainListResult
type CustomDomainListResultIterator = original.CustomDomainListResultIterator
type CustomDomainListResultPage = original.CustomDomainListResultPage
type CustomDomainParameters = original.CustomDomainParameters
type CustomDomainProperties = original.CustomDomainProperties
type CustomDomainPropertiesParameters = original.CustomDomainPropertiesParameters
type CustomDomainsClient = original.CustomDomainsClient
type CustomDomainsCreateFuture = original.CustomDomainsCreateFuture
type CustomDomainsDeleteFuture = original.CustomDomainsDeleteFuture
type CustomRule = original.CustomRule
type CustomRuleList = original.CustomRuleList
type DeepCreatedOrigin = original.DeepCreatedOrigin
type DeepCreatedOriginGroup = original.DeepCreatedOriginGroup
type DeepCreatedOriginGroupProperties = original.DeepCreatedOriginGroupProperties
type DeepCreatedOriginProperties = original.DeepCreatedOriginProperties
type DeliveryRule = original.DeliveryRule
type DeliveryRuleAction = original.DeliveryRuleAction
type DeliveryRuleCacheExpirationAction = original.DeliveryRuleCacheExpirationAction
type DeliveryRuleCacheKeyQueryStringAction = original.DeliveryRuleCacheKeyQueryStringAction
type DeliveryRuleCondition = original.DeliveryRuleCondition
type DeliveryRuleCookiesCondition = original.DeliveryRuleCookiesCondition
type DeliveryRuleHTTPVersionCondition = original.DeliveryRuleHTTPVersionCondition
type DeliveryRuleIsDeviceCondition = original.DeliveryRuleIsDeviceCondition
type DeliveryRulePostArgsCondition = original.DeliveryRulePostArgsCondition
type DeliveryRuleQueryStringCondition = original.DeliveryRuleQueryStringCondition
type DeliveryRuleRemoteAddressCondition = original.DeliveryRuleRemoteAddressCondition
type DeliveryRuleRequestBodyCondition = original.DeliveryRuleRequestBodyCondition
type DeliveryRuleRequestHeaderAction = original.DeliveryRuleRequestHeaderAction
type DeliveryRuleRequestHeaderCondition = original.DeliveryRuleRequestHeaderCondition
type DeliveryRuleRequestMethodCondition = original.DeliveryRuleRequestMethodCondition
type DeliveryRuleRequestSchemeCondition = original.DeliveryRuleRequestSchemeCondition
type DeliveryRuleRequestURICondition = original.DeliveryRuleRequestURICondition
type DeliveryRuleResponseHeaderAction = original.DeliveryRuleResponseHeaderAction
type DeliveryRuleURLFileExtensionCondition = original.DeliveryRuleURLFileExtensionCondition
type DeliveryRuleURLFileNameCondition = original.DeliveryRuleURLFileNameCondition
type DeliveryRuleURLPathCondition = original.DeliveryRuleURLPathCondition
type EdgeNode = original.EdgeNode
type EdgeNodeProperties = original.EdgeNodeProperties
type EdgeNodesClient = original.EdgeNodesClient
type EdgenodeResult = original.EdgenodeResult
type EdgenodeResultIterator = original.EdgenodeResultIterator
type EdgenodeResultPage = original.EdgenodeResultPage
type Endpoint = original.Endpoint
type EndpointListResult = original.EndpointListResult
type EndpointListResultIterator = original.EndpointListResultIterator
type EndpointListResultPage = original.EndpointListResultPage
type EndpointProperties = original.EndpointProperties
type EndpointPropertiesUpdateParameters = original.EndpointPropertiesUpdateParameters
type EndpointPropertiesUpdateParametersDeliveryPolicy = original.EndpointPropertiesUpdateParametersDeliveryPolicy
type EndpointPropertiesUpdateParametersWebApplicationFirewallPolicyLink = original.EndpointPropertiesUpdateParametersWebApplicationFirewallPolicyLink
type EndpointType = original.EndpointType
type EndpointUpdateParameters = original.EndpointUpdateParameters
type EndpointsClient = original.EndpointsClient
type EndpointsCreateFuture = original.EndpointsCreateFuture
type EndpointsDeleteFuture = original.EndpointsDeleteFuture
type EndpointsLoadContentFuture = original.EndpointsLoadContentFuture
type EndpointsPurgeContentFuture = original.EndpointsPurgeContentFuture
type EndpointsStartFuture = original.EndpointsStartFuture
type EndpointsStopFuture = original.EndpointsStopFuture
type EndpointsUpdateFuture = original.EndpointsUpdateFuture
type ErrorResponse = original.ErrorResponse
type GeoFilter = original.GeoFilter
type HTTPErrorRangeParameters = original.HTTPErrorRangeParameters
type HTTPVersionMatchConditionParameters = original.HTTPVersionMatchConditionParameters
type HeaderActionParameters = original.HeaderActionParameters
type HealthProbeParameters = original.HealthProbeParameters
type IPAddressGroup = original.IPAddressGroup
type IsDeviceMatchConditionParameters = original.IsDeviceMatchConditionParameters
type KeyVaultCertificateSourceParameters = original.KeyVaultCertificateSourceParameters
type KeyVaultSigningKeyParameters = original.KeyVaultSigningKeyParameters
type LoadParameters = original.LoadParameters
type ManagedHTTPSParameters = original.ManagedHTTPSParameters
type ManagedRuleDefinition = original.ManagedRuleDefinition
type ManagedRuleGroupDefinition = original.ManagedRuleGroupDefinition
type ManagedRuleGroupOverride = original.ManagedRuleGroupOverride
type ManagedRuleOverride = original.ManagedRuleOverride
type ManagedRuleSet = original.ManagedRuleSet
type ManagedRuleSetDefinition = original.ManagedRuleSetDefinition
type ManagedRuleSetDefinitionList = original.ManagedRuleSetDefinitionList
type ManagedRuleSetDefinitionListIterator = original.ManagedRuleSetDefinitionListIterator
type ManagedRuleSetDefinitionListPage = original.ManagedRuleSetDefinitionListPage
type ManagedRuleSetDefinitionProperties = original.ManagedRuleSetDefinitionProperties
type ManagedRuleSetList = original.ManagedRuleSetList
type ManagedRuleSetsClient = original.ManagedRuleSetsClient
type MatchCondition = original.MatchCondition
type Operation = original.Operation
type OperationDisplay = original.OperationDisplay
type OperationsClient = original.OperationsClient
type OperationsListResult = original.OperationsListResult
type OperationsListResultIterator = original.OperationsListResultIterator
type OperationsListResultPage = original.OperationsListResultPage
type Origin = original.Origin
type OriginGroup = original.OriginGroup
type OriginGroupListResult = original.OriginGroupListResult
type OriginGroupListResultIterator = original.OriginGroupListResultIterator
type OriginGroupListResultPage = original.OriginGroupListResultPage
type OriginGroupProperties = original.OriginGroupProperties
type OriginGroupUpdateParameters = original.OriginGroupUpdateParameters
type OriginGroupUpdatePropertiesParameters = original.OriginGroupUpdatePropertiesParameters
type OriginGroupsClient = original.OriginGroupsClient
type OriginGroupsCreateFuture = original.OriginGroupsCreateFuture
type OriginGroupsDeleteFuture = original.OriginGroupsDeleteFuture
type OriginGroupsUpdateFuture = original.OriginGroupsUpdateFuture
type OriginListResult = original.OriginListResult
type OriginListResultIterator = original.OriginListResultIterator
type OriginListResultPage = original.OriginListResultPage
type OriginProperties = original.OriginProperties
type OriginUpdateParameters = original.OriginUpdateParameters
type OriginUpdatePropertiesParameters = original.OriginUpdatePropertiesParameters
type OriginsClient = original.OriginsClient
type OriginsCreateFuture = original.OriginsCreateFuture
type OriginsDeleteFuture = original.OriginsDeleteFuture
type OriginsUpdateFuture = original.OriginsUpdateFuture
type PoliciesClient = original.PoliciesClient
type PoliciesCreateOrUpdateFuture = original.PoliciesCreateOrUpdateFuture
type PoliciesUpdateFuture = original.PoliciesUpdateFuture
type PolicySettings = original.PolicySettings
type PostArgsMatchConditionParameters = original.PostArgsMatchConditionParameters
type Profile = original.Profile
type ProfileListResult = original.ProfileListResult
type ProfileListResultIterator = original.ProfileListResultIterator
type ProfileListResultPage = original.ProfileListResultPage
type ProfileProperties = original.ProfileProperties
type ProfileUpdateParameters = original.ProfileUpdateParameters
type ProfilesClient = original.ProfilesClient
type ProfilesCreateFuture = original.ProfilesCreateFuture
type ProfilesDeleteFuture = original.ProfilesDeleteFuture
type ProfilesUpdateFuture = original.ProfilesUpdateFuture
type ProxyResource = original.ProxyResource
type PurgeParameters = original.PurgeParameters
type QueryStringMatchConditionParameters = original.QueryStringMatchConditionParameters
type RateLimitRule = original.RateLimitRule
type RateLimitRuleList = original.RateLimitRuleList
type RemoteAddressMatchConditionParameters = original.RemoteAddressMatchConditionParameters
type RequestBodyMatchConditionParameters = original.RequestBodyMatchConditionParameters
type RequestHeaderMatchConditionParameters = original.RequestHeaderMatchConditionParameters
type RequestMethodMatchConditionParameters = original.RequestMethodMatchConditionParameters
type RequestSchemeMatchConditionParameters = original.RequestSchemeMatchConditionParameters
type RequestURIMatchConditionParameters = original.RequestURIMatchConditionParameters
type Resource = original.Resource
type ResourceReference = original.ResourceReference
type ResourceUsage = original.ResourceUsage
type ResourceUsageClient = original.ResourceUsageClient
type ResourceUsageListResult = original.ResourceUsageListResult
type ResourceUsageListResultIterator = original.ResourceUsageListResultIterator
type ResourceUsageListResultPage = original.ResourceUsageListResultPage
type ResponseBasedOriginErrorDetectionParameters = original.ResponseBasedOriginErrorDetectionParameters
type Sku = original.Sku
type SsoURI = original.SsoURI
type SupportedOptimizationTypesListResult = original.SupportedOptimizationTypesListResult
type TrackedResource = original.TrackedResource
type URLFileExtensionMatchConditionParameters = original.URLFileExtensionMatchConditionParameters
type URLFileNameMatchConditionParameters = original.URLFileNameMatchConditionParameters
type URLPathMatchConditionParameters = original.URLPathMatchConditionParameters
type URLRedirectAction = original.URLRedirectAction
type URLRedirectActionParameters = original.URLRedirectActionParameters
type URLRewriteAction = original.URLRewriteAction
type URLRewriteActionParameters = original.URLRewriteActionParameters
type URLSigningActionParameters = original.URLSigningActionParameters
type URLSigningKey = original.URLSigningKey
type URLSigningParamIdentifier = original.URLSigningParamIdentifier
type UserManagedHTTPSParameters = original.UserManagedHTTPSParameters
type ValidateCustomDomainInput = original.ValidateCustomDomainInput
type ValidateCustomDomainOutput = original.ValidateCustomDomainOutput
type ValidateProbeInput = original.ValidateProbeInput
type ValidateProbeOutput = original.ValidateProbeOutput
type WebApplicationFirewallPolicy = original.WebApplicationFirewallPolicy
type WebApplicationFirewallPolicyList = original.WebApplicationFirewallPolicyList
type WebApplicationFirewallPolicyListIterator = original.WebApplicationFirewallPolicyListIterator
type WebApplicationFirewallPolicyListPage = original.WebApplicationFirewallPolicyListPage
type WebApplicationFirewallPolicyPatchParameters = original.WebApplicationFirewallPolicyPatchParameters
type WebApplicationFirewallPolicyProperties = original.WebApplicationFirewallPolicyProperties

func New(subscriptionID string, subscriptionID1 string) BaseClient {
	return original.New(subscriptionID, subscriptionID1)
}
func NewCustomDomainListResultIterator(page CustomDomainListResultPage) CustomDomainListResultIterator {
	return original.NewCustomDomainListResultIterator(page)
}
func NewCustomDomainListResultPage(getNextPage func(context.Context, CustomDomainListResult) (CustomDomainListResult, error)) CustomDomainListResultPage {
	return original.NewCustomDomainListResultPage(getNextPage)
}
func NewCustomDomainsClient(subscriptionID string, subscriptionID1 string) CustomDomainsClient {
	return original.NewCustomDomainsClient(subscriptionID, subscriptionID1)
}
func NewCustomDomainsClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) CustomDomainsClient {
	return original.NewCustomDomainsClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewEdgeNodesClient(subscriptionID string, subscriptionID1 string) EdgeNodesClient {
	return original.NewEdgeNodesClient(subscriptionID, subscriptionID1)
}
func NewEdgeNodesClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) EdgeNodesClient {
	return original.NewEdgeNodesClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewEdgenodeResultIterator(page EdgenodeResultPage) EdgenodeResultIterator {
	return original.NewEdgenodeResultIterator(page)
}
func NewEdgenodeResultPage(getNextPage func(context.Context, EdgenodeResult) (EdgenodeResult, error)) EdgenodeResultPage {
	return original.NewEdgenodeResultPage(getNextPage)
}
func NewEndpointListResultIterator(page EndpointListResultPage) EndpointListResultIterator {
	return original.NewEndpointListResultIterator(page)
}
func NewEndpointListResultPage(getNextPage func(context.Context, EndpointListResult) (EndpointListResult, error)) EndpointListResultPage {
	return original.NewEndpointListResultPage(getNextPage)
}
func NewEndpointsClient(subscriptionID string, subscriptionID1 string) EndpointsClient {
	return original.NewEndpointsClient(subscriptionID, subscriptionID1)
}
func NewEndpointsClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) EndpointsClient {
	return original.NewEndpointsClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewManagedRuleSetDefinitionListIterator(page ManagedRuleSetDefinitionListPage) ManagedRuleSetDefinitionListIterator {
	return original.NewManagedRuleSetDefinitionListIterator(page)
}
func NewManagedRuleSetDefinitionListPage(getNextPage func(context.Context, ManagedRuleSetDefinitionList) (ManagedRuleSetDefinitionList, error)) ManagedRuleSetDefinitionListPage {
	return original.NewManagedRuleSetDefinitionListPage(getNextPage)
}
func NewManagedRuleSetsClient(subscriptionID string, subscriptionID1 string) ManagedRuleSetsClient {
	return original.NewManagedRuleSetsClient(subscriptionID, subscriptionID1)
}
func NewManagedRuleSetsClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) ManagedRuleSetsClient {
	return original.NewManagedRuleSetsClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewOperationsClient(subscriptionID string, subscriptionID1 string) OperationsClient {
	return original.NewOperationsClient(subscriptionID, subscriptionID1)
}
func NewOperationsClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) OperationsClient {
	return original.NewOperationsClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewOperationsListResultIterator(page OperationsListResultPage) OperationsListResultIterator {
	return original.NewOperationsListResultIterator(page)
}
func NewOperationsListResultPage(getNextPage func(context.Context, OperationsListResult) (OperationsListResult, error)) OperationsListResultPage {
	return original.NewOperationsListResultPage(getNextPage)
}
func NewOriginGroupListResultIterator(page OriginGroupListResultPage) OriginGroupListResultIterator {
	return original.NewOriginGroupListResultIterator(page)
}
func NewOriginGroupListResultPage(getNextPage func(context.Context, OriginGroupListResult) (OriginGroupListResult, error)) OriginGroupListResultPage {
	return original.NewOriginGroupListResultPage(getNextPage)
}
func NewOriginGroupsClient(subscriptionID string, subscriptionID1 string) OriginGroupsClient {
	return original.NewOriginGroupsClient(subscriptionID, subscriptionID1)
}
func NewOriginGroupsClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) OriginGroupsClient {
	return original.NewOriginGroupsClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewOriginListResultIterator(page OriginListResultPage) OriginListResultIterator {
	return original.NewOriginListResultIterator(page)
}
func NewOriginListResultPage(getNextPage func(context.Context, OriginListResult) (OriginListResult, error)) OriginListResultPage {
	return original.NewOriginListResultPage(getNextPage)
}
func NewOriginsClient(subscriptionID string, subscriptionID1 string) OriginsClient {
	return original.NewOriginsClient(subscriptionID, subscriptionID1)
}
func NewOriginsClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) OriginsClient {
	return original.NewOriginsClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewPoliciesClient(subscriptionID string, subscriptionID1 string) PoliciesClient {
	return original.NewPoliciesClient(subscriptionID, subscriptionID1)
}
func NewPoliciesClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) PoliciesClient {
	return original.NewPoliciesClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewProfileListResultIterator(page ProfileListResultPage) ProfileListResultIterator {
	return original.NewProfileListResultIterator(page)
}
func NewProfileListResultPage(getNextPage func(context.Context, ProfileListResult) (ProfileListResult, error)) ProfileListResultPage {
	return original.NewProfileListResultPage(getNextPage)
}
func NewProfilesClient(subscriptionID string, subscriptionID1 string) ProfilesClient {
	return original.NewProfilesClient(subscriptionID, subscriptionID1)
}
func NewProfilesClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) ProfilesClient {
	return original.NewProfilesClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewResourceUsageClient(subscriptionID string, subscriptionID1 string) ResourceUsageClient {
	return original.NewResourceUsageClient(subscriptionID, subscriptionID1)
}
func NewResourceUsageClientWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) ResourceUsageClient {
	return original.NewResourceUsageClientWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func NewResourceUsageListResultIterator(page ResourceUsageListResultPage) ResourceUsageListResultIterator {
	return original.NewResourceUsageListResultIterator(page)
}
func NewResourceUsageListResultPage(getNextPage func(context.Context, ResourceUsageListResult) (ResourceUsageListResult, error)) ResourceUsageListResultPage {
	return original.NewResourceUsageListResultPage(getNextPage)
}
func NewWebApplicationFirewallPolicyListIterator(page WebApplicationFirewallPolicyListPage) WebApplicationFirewallPolicyListIterator {
	return original.NewWebApplicationFirewallPolicyListIterator(page)
}
func NewWebApplicationFirewallPolicyListPage(getNextPage func(context.Context, WebApplicationFirewallPolicyList) (WebApplicationFirewallPolicyList, error)) WebApplicationFirewallPolicyListPage {
	return original.NewWebApplicationFirewallPolicyListPage(getNextPage)
}
func NewWithBaseURI(baseURI string, subscriptionID string, subscriptionID1 string) BaseClient {
	return original.NewWithBaseURI(baseURI, subscriptionID, subscriptionID1)
}
func PossibleActionTypeValues() []ActionType {
	return original.PossibleActionTypeValues()
}
func PossibleAlgorithmValues() []Algorithm {
	return original.PossibleAlgorithmValues()
}
func PossibleCacheBehaviorValues() []CacheBehavior {
	return original.PossibleCacheBehaviorValues()
}
func PossibleCertificateSourceValues() []CertificateSource {
	return original.PossibleCertificateSourceValues()
}
func PossibleCertificateTypeValues() []CertificateType {
	return original.PossibleCertificateTypeValues()
}
func PossibleCookiesOperatorValues() []CookiesOperator {
	return original.PossibleCookiesOperatorValues()
}
func PossibleCustomDomainResourceStateValues() []CustomDomainResourceState {
	return original.PossibleCustomDomainResourceStateValues()
}
func PossibleCustomHTTPSProvisioningStateValues() []CustomHTTPSProvisioningState {
	return original.PossibleCustomHTTPSProvisioningStateValues()
}
func PossibleCustomHTTPSProvisioningSubstateValues() []CustomHTTPSProvisioningSubstate {
	return original.PossibleCustomHTTPSProvisioningSubstateValues()
}
func PossibleCustomRuleEnabledStateValues() []CustomRuleEnabledState {
	return original.PossibleCustomRuleEnabledStateValues()
}
func PossibleDestinationProtocolValues() []DestinationProtocol {
	return original.PossibleDestinationProtocolValues()
}
func PossibleEndpointResourceStateValues() []EndpointResourceState {
	return original.PossibleEndpointResourceStateValues()
}
func PossibleGeoFilterActionsValues() []GeoFilterActions {
	return original.PossibleGeoFilterActionsValues()
}
func PossibleHeaderActionValues() []HeaderAction {
	return original.PossibleHeaderActionValues()
}
func PossibleHealthProbeRequestTypeValues() []HealthProbeRequestType {
	return original.PossibleHealthProbeRequestTypeValues()
}
func PossibleManagedRuleEnabledStateValues() []ManagedRuleEnabledState {
	return original.PossibleManagedRuleEnabledStateValues()
}
func PossibleMatchVariableValues() []MatchVariable {
	return original.PossibleMatchVariableValues()
}
func PossibleMinimumTLSVersionValues() []MinimumTLSVersion {
	return original.PossibleMinimumTLSVersionValues()
}
func PossibleNameBasicDeliveryRuleActionValues() []NameBasicDeliveryRuleAction {
	return original.PossibleNameBasicDeliveryRuleActionValues()
}
func PossibleNameValues() []Name {
	return original.PossibleNameValues()
}
func PossibleOperatorValues() []Operator {
	return original.PossibleOperatorValues()
}
func PossibleOptimizationTypeValues() []OptimizationType {
	return original.PossibleOptimizationTypeValues()
}
func PossibleOriginGroupResourceStateValues() []OriginGroupResourceState {
	return original.PossibleOriginGroupResourceStateValues()
}
func PossibleOriginResourceStateValues() []OriginResourceState {
	return original.PossibleOriginResourceStateValues()
}
func PossibleParamIndicatorValues() []ParamIndicator {
	return original.PossibleParamIndicatorValues()
}
func PossiblePolicyEnabledStateValues() []PolicyEnabledState {
	return original.PossiblePolicyEnabledStateValues()
}
func PossiblePolicyModeValues() []PolicyMode {
	return original.PossiblePolicyModeValues()
}
func PossiblePolicyResourceStateValues() []PolicyResourceState {
	return original.PossiblePolicyResourceStateValues()
}
func PossiblePostArgsOperatorValues() []PostArgsOperator {
	return original.PossiblePostArgsOperatorValues()
}
func PossiblePrivateEndpointStatusValues() []PrivateEndpointStatus {
	return original.PossiblePrivateEndpointStatusValues()
}
func PossibleProbeProtocolValues() []ProbeProtocol {
	return original.PossibleProbeProtocolValues()
}
func PossibleProfileResourceStateValues() []ProfileResourceState {
	return original.PossibleProfileResourceStateValues()
}
func PossibleProtocolTypeValues() []ProtocolType {
	return original.PossibleProtocolTypeValues()
}
func PossibleProvisioningStateValues() []ProvisioningState {
	return original.PossibleProvisioningStateValues()
}
func PossibleQueryStringBehaviorValues() []QueryStringBehavior {
	return original.PossibleQueryStringBehaviorValues()
}
func PossibleQueryStringCachingBehaviorValues() []QueryStringCachingBehavior {
	return original.PossibleQueryStringCachingBehaviorValues()
}
func PossibleQueryStringOperatorValues() []QueryStringOperator {
	return original.PossibleQueryStringOperatorValues()
}
func PossibleRedirectTypeValues() []RedirectType {
	return original.PossibleRedirectTypeValues()
}
func PossibleRemoteAddressOperatorValues() []RemoteAddressOperator {
	return original.PossibleRemoteAddressOperatorValues()
}
func PossibleRequestBodyOperatorValues() []RequestBodyOperator {
	return original.PossibleRequestBodyOperatorValues()
}
func PossibleRequestHeaderOperatorValues() []RequestHeaderOperator {
	return original.PossibleRequestHeaderOperatorValues()
}
func PossibleRequestURIOperatorValues() []RequestURIOperator {
	return original.PossibleRequestURIOperatorValues()
}
func PossibleResourceTypeValues() []ResourceType {
	return original.PossibleResourceTypeValues()
}
func PossibleResponseBasedDetectedErrorTypesValues() []ResponseBasedDetectedErrorTypes {
	return original.PossibleResponseBasedDetectedErrorTypesValues()
}
func PossibleSkuNameValues() []SkuName {
	return original.PossibleSkuNameValues()
}
func PossibleTransformTypeValues() []TransformType {
	return original.PossibleTransformTypeValues()
}
func PossibleTransformValues() []Transform {
	return original.PossibleTransformValues()
}
func PossibleURLFileExtensionOperatorValues() []URLFileExtensionOperator {
	return original.PossibleURLFileExtensionOperatorValues()
}
func PossibleURLFileNameOperatorValues() []URLFileNameOperator {
	return original.PossibleURLFileNameOperatorValues()
}
func PossibleURLPathOperatorValues() []URLPathOperator {
	return original.PossibleURLPathOperatorValues()
}
func UserAgent() string {
	return original.UserAgent() + " profiles/preview"
}
func Version() string {
	return original.Version()
}
